package com.diagbot.facade;

import com.diagbot.biz.push.entity.Pacs;
import com.diagbot.biz.push.entity.Lis;
import com.diagbot.dto.BillDTO;
import com.diagbot.dto.BillNeoDTO;
import com.diagbot.dto.WordCrfDTO;
import com.diagbot.process.BillProcess;
import com.diagbot.vo.BillNeoVO;
import com.diagbot.vo.IndicationPushVO;
import com.diagbot.vo.StandConvert;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.diagbot.biz.push.entity.Item;

import java.util.List;

import java.util.Map;

/**
 * @Description: 开单合理性facade
 * @author: zhoutg
 * @time: 2018/8/6 9:11
 */
@Component
public class BillFacade {

    @Autowired
    NeoFacade neoFacade;
    @Autowired
    BillProcess billProcess;
    @Autowired
    CommonFacade commonFacade;

    /**
     * 开单合理性业务
     * @param
     * @return
     */
    public BillDTO billFac(IndicationPushVO indicationPushVO) {
        // 模型处理数据
        WordCrfDTO wordCrfDTO = commonFacade.crf_process(indicationPushVO);

        // 标准词转换
        StandConvert standConvert = commonFacade.dataTypeGet(wordCrfDTO);
        Map<String, Map<String, String>> typeStand = neoFacade.standConvert(standConvert);
//        wordCrfDTO = commonFacade.dataTypeSet(wordCrfDTO, typeStand);

        // 开单合理性图谱接口调用
        BillNeoVO billNeoVO = fillBillNeo(indicationPushVO);

        List<BillNeoDTO> billNeoDTOList = neoFacade.getBillNeo(billNeoVO);

        // 获取药品缓存信息，现在不用
        // neoFacade.getDrugCache();

        // 规则开发
       return billProcess.process(billNeoDTOList, wordCrfDTO);
    }


    public BillNeoVO fillBillNeo(IndicationPushVO indicationPushVO) {
        BillNeoVO billNeoVO = new BillNeoVO();

        List<Item> items = indicationPushVO.getDrugOrder();
        for (Item item : items) {
            billNeoVO.getDrugList().add(item.getName());
        }
        List<Pacs> pacslist = indicationPushVO.getPacs();
        for (Pacs pacs : pacslist) {
            billNeoVO.getPacsList().add(pacs.getName());
        }
        List<Lis> lislist = indicationPushVO.getLis();
        for (Lis lis : lislist) {
            billNeoVO.getLisList().add(lis.getName());
        }

        return billNeoVO;
    }
}
