package com.diagbot.repository;

import com.diagbot.dto.LisBillNeoDTO;
import com.diagbot.dto.RangeNeoDTO;
import com.diagbot.entity.node.*;

import java.math.BigDecimal;
import java.util.Set;

public class LISNode {

	public LisBillNeoDTO ListoLISDTO(LIS lis) {

		LisBillNeoDTO lisBillNeoDTO = new LisBillNeoDTO();

		Gender gender = lis.getGender();
		String gender_val = (gender==null)?"":gender.getName();
		lisBillNeoDTO.setGender(gender_val);


		Age age = lis.getAge();
		if (null!=age) {
			RangeNeoDTO ageNeoDTO = new RangeNeoDTO();
			ageNeoDTO.setMin(BigDecimal.valueOf(age.getMinval()));
			ageNeoDTO.setMax(BigDecimal.valueOf(age.getMaxval()));
			lisBillNeoDTO.setAgeNeoDTO(ageNeoDTO);
		}

		Set<ClinicalFinding> clinicalfindings = lis.getClinicalfindings();
		for (ClinicalFinding clinicalfinding : clinicalfindings) {
			String clinicalfinding_val = (clinicalfinding==null)?"":clinicalfinding.getName();
			lisBillNeoDTO.getClinicfindings().add(clinicalfinding_val);
		}

		Set<Medicine> conflict_medicines = lis.getConflict_medicines();
		for (Medicine conflict_medicine : conflict_medicines) {
			String medicine_val = (conflict_medicine==null)?"":conflict_medicine.getName();
			lisBillNeoDTO.getPrescribe().add(medicine_val);
		}

		Set<AllergicMed> allergicmeds = lis.getAllergicmeds();
		for (AllergicMed allergicmed : allergicmeds) {
			String allergicmed_val = (allergicmed==null)?"":allergicmed.getName();
			lisBillNeoDTO.getAllergmeds().add(allergicmed_val);
		}

		Set<Operation> operations = lis.getOperations();
		for (Operation operation : operations) {
			String operation_val = (operation==null)?"":operation.getName();
			lisBillNeoDTO.getOperations().add(operation_val);
		}

		Set<Procedure> procedures = lis.getProcedures();
		for (Procedure procedure : procedures) {
			String procedure_val = (procedure==null)?"":procedure.getName();
			lisBillNeoDTO.getProcedures().add(procedure_val);
		}

		Set<PACS> pacss = lis.getPacs();
		for (PACS pacs : pacss) {
			String pacs_val = (pacs==null)?"":pacs.getName();
			lisBillNeoDTO.getPacs().add(pacs_val);
		}

		Set<Disease> diseases = lis.getDiseases();
		for (Disease disease : diseases) {
			String disease_val = (disease==null)?"":disease.getName();
			lisBillNeoDTO.getDisease().add(disease_val);
		}

		Set<Group> groups = lis.getGroups();
		for (Group group : groups) {
			String group_val = (group==null)?"":group.getName();
			lisBillNeoDTO.getGroup().add(group_val);
		}


		return lisBillNeoDTO;
	}
}

