package com.diagbot.repository;

import com.diagbot.dto.PacsBillNeoDTO;
import com.diagbot.dto.RangeNeoDTO;
import com.diagbot.entity.node.*;

import java.math.BigDecimal;
import java.util.Set;

public class PACSNode {

    public PacsBillNeoDTO PacstoPACSDTO(PACS pacs) {
        PacsBillNeoDTO pacsBillNeoDTO = new PacsBillNeoDTO();

        Age age = pacs.getAge();
        if (age!=null) {
            RangeNeoDTO ageNeoDTO = new RangeNeoDTO();
            ageNeoDTO.setMin(BigDecimal.valueOf(age.getMinval()));
            ageNeoDTO.setMax(BigDecimal.valueOf(age.getMaxval()));
            pacsBillNeoDTO.setAgeNeoDTO(ageNeoDTO);
        }


        Gender gender = pacs.getGender();
        String gender_val = (gender==null)?"":gender.getName();
        pacsBillNeoDTO.setGender(gender_val);


        Set<ClinicalFinding> clinicalfindings = pacs.getClinicalfindings();
        for (ClinicalFinding clinicalfinding : clinicalfindings) {
            RangeNeoDTO rangeNeoDTO = new RangeNeoDTO();
            String clinicalfinding_val = (clinicalfinding == null) ? "" : clinicalfinding.getName();
            rangeNeoDTO.setName(clinicalfinding_val);

            if (clinicalfinding.getUnit()!=null) {
                rangeNeoDTO.setUnit(clinicalfinding.getUnit());
                if (null!=clinicalfinding.getMinval()) {
                    rangeNeoDTO.setMin(new BigDecimal(clinicalfinding.getMinval()));
                }
                if (null!=clinicalfinding.getMaxval()) {
                    rangeNeoDTO.setMax(new BigDecimal(clinicalfinding.getMaxval()));
                }
            }

            pacsBillNeoDTO.getClinicfindings().add(rangeNeoDTO);
        }

        Set<Medicine> conflict_medicines = pacs.getConflict_medicines();
        for (Medicine conflict_medicine : conflict_medicines) {
            String medicine_val = (conflict_medicine==null)?"":conflict_medicine.getName();
            pacsBillNeoDTO.getPrescribe().add(medicine_val);
        }

        Set<AllergicMed> allergicmeds = pacs.getAllergicmeds();
        for (AllergicMed allergicmed : allergicmeds) {
            String allergicmed_val = (allergicmed==null)?"":allergicmed.getName();
            pacsBillNeoDTO.getAllergicmeds().add(allergicmed_val);
        }

        Set<Operation> operations = pacs.getOperations();
        for (Operation operation : operations) {
            String operation_val = (operation==null)?"":operation.getName();
            pacsBillNeoDTO.getOperations().add(operation_val);
        }

        Set<Procedure> procedures = pacs.getProcedures();
        for (Procedure procedure : procedures) {
            String procedure_val = (procedure==null)?"":procedure.getName();
            pacsBillNeoDTO.getProcedures().add(procedure_val);
        }

        Set<LIS> liss = pacs.getLiss();
        for (LIS lis : liss) {
            String lis_val = (lis==null)?"":lis.getName();
            pacsBillNeoDTO.getLis().add(lis_val);
        }

        Set<Disease> diseases = pacs.getDiseases();
        for (Disease disease : diseases) {
            String disease_val = (disease==null)?"":disease.getName();
            pacsBillNeoDTO.getDisease().add(disease_val);
        }

        Set<Group> groups = pacs.getGroups();
        for (Group group : groups) {
            String group_val = (group==null)?"":group.getName();
            pacsBillNeoDTO.getGroup().add(group_val);
        }


        return pacsBillNeoDTO;
    }
}






