package com.diagbot.rule;

import com.diagbot.dto.RangeNeoDTO;
import com.diagbot.dto.BillMsg;
import com.diagbot.dto.WordCrfDTO;
import com.diagbot.util.CoreUtil;

import java.math.BigDecimal;

/**
 * @description: 年龄规则
 * @author: zhoutg
 * @time: 2020/8/3 14:47
 */
public class AgeRule {

    /**
     * 年龄比较
     *
     * @param ageNeoDTO
     * @param wordCrfDTO
     * @param name
     * @return
     */
    public static BillMsg compareAgeWithBill(RangeNeoDTO ageNeoDTO, WordCrfDTO wordCrfDTO, String name) {
        Boolean flag = false;
        if (ageNeoDTO != null && wordCrfDTO.getAge() != null) {
            Integer age = wordCrfDTO.getAge();
            Integer minAge = ageNeoDTO.getMin().intValue();
            if (minAge != null) {
                if (age < minAge) {
                    flag = true;
                }
            }
            Integer maxAge = ageNeoDTO.getMax().intValue();
            if (maxAge != null) {
                if (age > minAge) {
                    flag = true;
                }
            }
        }
        if (flag) {
            return CoreUtil.getCommonBillMsg(String.valueOf(wordCrfDTO.getAge() + "岁"), name);
        }
        return null;
    }
}
